CPU 286
BITS 16
ORG -12
    db 'DRV>'   ; It's a driver
    db 0        ; Flags
    db 6        ; Type (Display-driver)
    dw 0        ; Numload (entire file)
    dd 0        ; Reported length (0)

    push cs
    pop ds

    cmp ax, 0600h
    jb deadfunc
    cmp ax, 0622h
    jnbe deadfunc2
    sub ax, 0600h
    push bx
    shl ax, 1
    mov bx, ax
    add bx, ftab6
    mov ax, [bx]
    pop bx
    or ax, ax
    jz deadfunc2

    jmp ax

deadfunc:
    cmp ax, 0
    jz doinit
    cmp ax, 4
    jz uninit
deadfunc2:
    mov ax, 0xDEAD
    retf



getpixel:
    mov ah, cl
    mov al, 0
    shl cx, 6
    add ax, cx
    add ax, bx
    mov di, ax
    mov ax, 0a000h
    mov es, ax
    mov al, [es:di]
    mov ah, 0
    mov si, ax
    retf

doinit:
    xor ax, ax
    mov bx, drvnam
    retf

uninit:
    mov ax, 3   ; Make sure we're in textmode
    int 10h
    retf

setmode:
    cmp bx, 320
    jnz notm
    cmp cx, 200
    jnz notm
    cmp dh, 8
    jz modok
notm: mov ax, 0xDEAD
    retf
modok:
    mov ax, 13h
    int 10h
    mov ax, 1       ; DDB_8BIT_PLANAR
    retf

setpixel:
    mov ah, cl
    mov al, 0
    shl cx, 6
    add ax, cx
    add ax, bx
    mov di, ax
    mov bx, si
    push es
    mov ax, 0a000h
    mov es, ax
    mov [es:di], bl
    pop es
    retf

hline:
    sub dx, bx
    mov ah, cl
    mov al, 0
    shl cx, 6
    add ax, cx
    add ax, bx
    mov di, ax
    mov bx, si
    push es
    mov ax, 0a000h
    mov es, ax
    mov cx, dx
    inc cx
    mov al, bl
    call mystosb
    pop es
    retf

vline:
    sub dx, bx
    mov ah, bl
    mov al, 0
    shl bx, 6
    add ax, cx
    add ax, bx
    mov di, ax
    mov bx, si
    push es
    mov ax, 0a000h
    mov es, ax
    inc dx
    mov al, bl
        vlineloop:
        stosb
        add di, 319
        dec dx
        jnz vlineloop
    pop es
    retf

sprite:
    push bp
    push es
    pop ds
    mov bp, 320
    sub bp, bx
    push bp
    mov ah, cl
    mov al, 0
    shl cx, 6
    add ax, cx
    add ax, bx
    mov di, ax
    mov ax, 0a000h
    mov es, ax
    mov dx, di
        spriteloop:
        cmp di, 64000
        jnbe spriteend

        lodsb

        cmp al, 10
        jz spritelf
        cmp al, 13
        jz spritecr

        or bp, bp
        jz spriteloop
        dec bp

        cmp al, ' '
        jz spritespace
        cmp al, '*'
        jz spriteneg
        cmp al, 8
        jz spriteback
        cmp al, 0
        jz spriteend


        or al, 32
        sub al, 97
        stosb
        jmp spriteloop

        spritespace:
        inc di
        jmp spriteloop

        spriteneg:
        mov al, [es:di]
        neg al
        stosb
        jmp spriteloop

        spritelf:
        pop bp
        push bp
        add dx, 320
        spritecr:
        mov di, dx
        jmp spriteloop

        spriteback:
        dec di
        jmp spriteloop

    spriteend:
    pop bp
    pop bp
    retf

set0815:
    push bp
    push es
    pop ds
    mov ah, cl
    mov al, 0
    shl cx, 6
    add ax, cx
    add ax, bx
    mov di, ax
    mov ax, 0a000h
    mov es, ax
    mov dx, di
    lodsw
    mov bx, ax
    lodsw
    mov bp, ax
        ; Regs: BX=X BP=Y DS:SI=pic ES:DI/DX=vram
        setloop:
        mov cx, bx
        plotpixels:
        lodsw
        cmp ax, 0F00h
        jz ojstos
        stosb
        instos:
        dec cx
        jnz plotpixels
        add dx, 320
        mov di, dx
        dec bp
        jnz setloop
    pop bp
    retf

    ojstos:
    inc di
    jmp instos


get0815:
    push bp
    mov dx, [es:di] ; x
    mov bp, [es:di+2] ; y
    add di, 4
    mov ah, cl
    mov al, 0
    shl cx, 6
    add ax, cx
    add ax, bx
    mov si, ax
    mov ax, 0a000h
    mov ds, ax
    mov ah, 0
        ; DS:SI=vram ES:DI=datablk DX=Width BP=Height
        getloop:
        mov cx, dx
            readpixels:
            lodsb
            stosw
            dec cx
            jnz readpixels
        add si, 320
        sub si, dx
        dec bp
        jnz getloop
    pop bp
    retf

clrscr:
    mov ax, 0A000h
    mov es, ax
    xor di, di
    mov cx, 32000
    mov al, bl
    mov ah, bl
    rep stosw
    retf

rectf:
    push bp
    sub dx, bx
    sub di, cx
    inc dx
    inc di
    push si
    push dx
    push di

    push es
    pop ds
    mov ah, cl
    mov al, 0
    shl cx, 6
    add ax, cx
    add ax, bx
    mov di, ax
    mov ax, 0a000h
    mov es, ax
    mov dx, di
    pop bp
    pop bx
    pop ax
        ; Regs: BX=X BP=Y ES:DI/DX=vram
        rectloop:
        mov cx, bx
        call mystosb
        add dx, 320
        mov di, dx
        dec bp
        jnz rectloop
    pop bp
    retf

drawddb:
    push bp
    push es
    pop ds
    mov ah, cl
    mov al, 0
    shl cx, 6
    add ax, cx
    add ax, bx
    mov di, ax
    mov ax, 0a000h
    mov es, ax
    mov dx, di
    lodsw
    mov bx, ax
    lodsw
    mov bp, ax
        ; Regs: BX=X BP=Y DS:SI=pic ES:DI/DX=vram
        setloopsmall:
        mov cx, bx
        call mymovsb
        add dx, 320
        mov di, dx
        cmp di, 64000
        jnbe setloopexit
        dec bp
        jnz setloopsmall
setloopexit: pop bp
    retf

getddb:
    push bp
    mov dx, [es:di] ; x
    mov bp, [es:di+2] ; y
    add di, 4
    mov ah, cl
    mov al, 0
    shl cx, 6
    add ax, cx
    add ax, bx
    mov si, ax
    mov ax, 0a000h
    mov ds, ax
    mov ah, 0
        ; DS:SI=vram ES:DI=datablk DX=Width BP=Height
        getdloop:
        mov cx, dx
        call mymovsb
        add si, 320
        sub si, dx
        cmp si, 64000
        jnbe getloopexit
        dec bp
        jnz getdloop
    getloopexit:
    pop bp
    retf

mymovsb:
    shr cx, 1
    jc ungradm
    rep movsw
    ret
ungradm:
    rep movsw
    lobsb
    stosb
    ret

mystosb:
    mov ah, al
    shr cx, 1
    jc ungrads
    rep stosw
    ret
ungrads:
    rep stosw
    stosb
    ret

;drawsimpfnt:
;    push ds
;    pop es
;    mov ah, cl
;    mov al, 0
;    shl cx, 6
;    add ax, cx
;    add ax, bx
;    mov di, ax
;    mov ax, 0a000h
;    mov es, ax
;        ; ES:DI=VRAM-ADDR DS:SI=CHAR DX=Height
;    mov bx, dx
;        ; BX=Height left
;
;    lodsb

dline:
    cmp di, 0
    jnz dlinel
    mov ax, 318
    jmp dgotn
dlinel:
    mov ax, 320
dgotn:
    push ax

    mov ah, bl
    mov al, 0
    shl bx, 6
    add ax, cx
    add ax, bx
    mov di, ax
    mov bx, si
    mov ax, 0a000h
    mov es, ax
    inc dx
    pop cx
    mov al, bl
        dlineloop:
        stosb
        add di, cx
        dec dx
        jnz dlineloop
    retf

drvnam:     db '320x200x8',0
ftab6:
    dw setmode      ; 0600h
    dw setpixel     ; 0601h
    dw getpixel     ; 0602h
    dw hline        ; 0603h
    dw vline        ; 0604h
    dw 0            ; 0605h
    dw rectf        ; 0606h
    dw sprite       ; 0607h
    dw set0815      ; 0608h
    dw get0815      ; 0609h
    dw dline        ; 060Ah
    dw 0            ; 060Bh
    dw 0            ; 060Ch
    dw 0            ; 060Dh
    dw 0            ; 060Eh
    dw 0            ; 060Fh
    dw clrscr       ; 0610h
    dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 0611h-0620h
    dw drawddb      ; 0621h
    dw getddb       ; 0622h
