CPU 286
ORG -5

%include "const.inc"

    db '->'     ; Begin
    db 2        ; Flags
    dw eoflbl+256

;-------------------------------------------------

        mov ax, cs
        mov ds, ax
        mov [storcs], ax
        mov [storcs2], ax

        mov ax, 26h
        int 0F0h
        mov [myself], bx

        mov ax, 1016h       ; Create window
        mov si, wndstruct
        int 0F0h
        mov [wnd], ax

        mov ax, 22h         ; set message status
        mov bx, MS_WANTTIMERMSG
        int 0F0h

        mov ax, 35FEh           ; Get Some Info
        int 21h
        mov [dataseg], es
        mov [dataoff], bx
        mov si, bx

    ; ---- INIT
        call putfood

dotswitch:
mainexecloop:
        mov ax, 10h             ; getmessage
        int 0f0h
        mov ax, 2000h           ; dispatchmessage
        int 0f0h
        cmp dx, MSG_GENERICTIMER
        jz domove
        cmp si, [wnd]
        jnz mainexecloop

        mov si, [dataoff]

        cmp dx, MSG_KEYPRESS
        jz kbhit
        cmp dx, MSG_KEYDOWN
        jz extrakey
        cmp dx, MSG_PAINT
        jz dopaintme
        cmp dx, MSG_CLOSEWND
        jz quitme
        jmp mainexecloop

dopaintme: jmp paintme
domove:
        mov si, [dataoff]
        cmp BYTE [dopause], 0       ; Pause
        jz mainexecloop
        call movesnake
        jmp dotswitch
        
quitme:

    ; ---- TERMINATION

        xor ax,ax               ; Function 0 - Kill
        int 0F0h                ; DO that (bye,bye)

kbhit:
        mov ax, di

    ; ---- Q=Quit, but you can modify this here

        mov ah, al

        cmp al, 'q'             ; q(uit)
        jz quitme
        cmp al, 'd'             ; (re)d(raw)
        jz dopaintme
        cmp al, 'p'             ; p(ause)
        jnz extrakey

        not BYTE [dopause]
        jmp dotswitch

extrakey:
        mov ax, di
        mov ah, al
        mov al, 1

        cmp ah, 75
        jz domoveme
        inc al
        cmp ah, 77
        jz domoveme
        inc al
        cmp ah, 72
        jz domoveme
        inc al
        cmp ah, 80
        jz domoveme
        jmp dotswitch

domoveme:
        mov [snakedir], al
        jmp dotswitch


paintme:

    ; ---- PAINTING

        ; Fill black
        mov ax, 82h             ; Function 82h - Draw
        mov [es:si], ax
        mov ax, 5h              ; SubFunction 5h - paint rectangle
        mov [es:si+2], ax
        mov ax, 0FFFFh          ; FFFFh - Paint entire rectangle
        mov [es:si+4], ax
        mov ax, 0               ; Color 0
        mov [es:si+12], ax
        int 0FFh                ; DO that!

        ; Draw the playfield-rect
        mov ax, 10h             ; SubFunction 10h - draw border around
        mov [es:si+2], ax
        mov ax, 12
        mov [es:si+4], ax
        int 0FFh

        ; Draw the statusline
        call drawstatusline

        ; Paint the snake
        mov dx, [snakelen]
        dec dx
        jz nopaint
        dec dx
aloop:  mov bx, snakepos        ; Get Pos.
        add bx, dx
        add bx, dx
        mov ch, [bx]            ; In CH
        mov cl, [bx+1]          ; and CL
        mov ah, 15
        call drawthatpos        ; And color it
        dec dx
        cmp dx, 0FFFFh          ; Until finished
        jnz aloop

        ; Paint the food
nopaint:
        call redrawfood

        jmp dotswitch           ; Let's make a taskswitch

    ; ---- Subs

    ; Draws position given in CX (CH=Row, CL=Col), AH=Color
drawthatpos:
        mov al, ah              ; Color
        mov ah, 0

        mov [es:si+8], ax
        mov al, 82h             ; Function 82h - Draw
        mov [es:si], ax
        mov al, 0eh             ; SubFunction 0eh - Paint area
        mov [es:si+2], ax
        mov al, cl              ; Col
        mov [es:si+4],ax
        mov al, ch              ; Row
        mov [es:si+6],ax
        mov [es:si+10], cs      ; Seg
        mov ax, fieldinfoblock
        mov [es:si+12], ax      ; Off
        int 0FFh
        ret

makestatusline:
        mov ax, 0eh             ; Function e - inttostr
        mov [es:si], ax
        mov ax, [score]         ; Int
        mov [es:si+2], ax
        mov [es:si+4], cs       ; Seg
        mov ax, snscore
        mov [es:si+6], ax       ; Off
        mov ax, 10
        mov [es:si+8], ax       ; Len
        int 0FFh                ; Go!

drawstatusline:
        mov ax, 82h             ; Function 82h - Draw
        mov [es:si], ax         
        mov ax, 6h              ; SubFunction 6h - textout
        mov [es:si+2], ax
        xor ax, ax              ; X=0
        mov [es:si+4], ax
        dec ax                  ; Y=FFFF (Statusline)
        mov [es:si+6], ax
        mov ax, 9               ; FG=9
        mov [es:si+8], ax
        mov ax, 0               ; BG=0
        mov [es:si+10], ax
        mov ax, 0               ; Fntid
        mov [es:si+12], ax
        mov [es:si+14], cs      ; Seg
        mov ax, snstatus
        mov [es:si+16], ax      ; Off
        int 0FFh                ; Do It!
        ret

        jmp quitme

    ; Easy: Moves the snake
movesnake:
        mov ah, [snakedir]
        mov ch, [snakehead]     ; CH=Row
        mov cl, [snakehead+1]   ; CL=Col

        cmp ah, 1
            jnz psw1
            dec cl
            psw1:
        cmp ah, 2
            jnz psw2
            inc cl
            psw2:
        cmp ah, 3
            jnz psw3
            dec ch
            psw3:
        cmp ah, 4
            jnz psw4
            inc ch
            psw4:

    ; Move the snake
        mov bx, [snakelen]
mvsnkl:
        shl bx, 1                   ; BX*2
        mov ax, [snakepos+bx]       ; Get pos BX
        mov [snakepos+2+bx], ax     ; Put it to BX+2
        shr bx, 1

        dec bx                      ; Get nearer to head
        cmp bx, 0FFFFh              ; Done?
        jnz mvsnkl                  ; No->Jump

    ; Set the new head
        mov [snakehead], ch         ; Head
        mov [snakehead+1], cl       ; Head
        mov ah, 15                  ; Draw Pos. in Color 15
        call drawthatpos            ; Go!

        cmp ch, 0
        jz killsnake
        cmp cl, 0
        jz killsnake
        cmp ch, 49
        jz killsnake
        cmp cl, 79
        jz killsnake

        mov ax, [snakehead]

        mov dx, [snakelen]
        dec dx
        cmp dx, 0
        jz nocrash

nobloop: mov bx, snakepos        ; Get Pos.
        add bx, dx
        add bx, dx
        mov cx, [bx]            ; In CX
        cmp ax, cx              ; Same pos?
        jz killsnake            ; Yes -> ReRandomize
        dec dx
        jnz nobloop
nocrash:
        cmp ax, [foodpos]           ; Is there some food?
        jz eatfood
foodeaten:

    ; Check for len-update
        mov ax, [snakeadd]
        or ax, ax                   ; Add something?
        jz noadd                    ; No->Don't do that
        dec ax                      ; Dec. the adder
        mov [snakeadd], ax          
        inc WORD [snakelen]         ; But increase the length
        jmp adddone                 ; Adding done
noadd:                          ; No adding:
        mov bx, [snakelen]          ; Get length
        dec bx
        shl bx, 1
        mov ch, [snakepos+bx]       ; And get the position
        mov cl, [snakepos+bx+1]     ; And get the position
        mov ah, 0                   ; Draw Pos. in Color 0
        call drawthatpos            ; Go!
adddone:
        ret                         ; We're donw

killsnake:
        mov ax, 'Yo'
        mov [yscore], ax
        mov ax, 'ur'
        mov [yscore+2], ax

        mov ax, 07Bh
        mov [es:si], ax
        mov [es:si+2], cs
        mov ax, yscoreptr
        mov [es:si+4], ax
        int 0FFh
        jmp quitme

eatfood:
        inc WORD [score]
        call makestatusline
        mov ax, 2
        add [snakeadd], ax
        call putfood
        jmp foodeaten

redrawfood:
        mov dh, [foodpos]
        mov dl, [foodpos+1]
        jmp xyeredzgh

    ; Puts the food anywhere on the screen
putfood:
        mov ax, 11h                 ; Function 11 - Randomize
        mov [es:si], ax
        mov ax, 23                  ; 0..22
        mov [es:si+2], ax
        int 0FFh
        mov dh, [es:si+4]
        inc dh

        mov ax, 78                  ; 0..77
        mov [es:si+2], ax
        int 0FFh
        mov dl, [es:si+4]
        inc dl

 ; Now look in the snake
        mov ax, [snakelen]
        dec ax
noaloop: mov bx, snakepos        ; Get Pos.
        add bx, ax
        add bx, ax
        mov ch, [bx]            ; In CH
        mov cl, [bx+1]          ; and CL
        cmp dx, cx              ; Same pos?
        jz putfood              ; Yes -> ReRandomize
        dec ax
        cmp ax, 0FFFFh          ; Until finished
        jnz noaloop
 ; Pos. seems to be OK
        mov [foodpos], dh
        mov [foodpos+1], dl
xyeredzgh:
        mov ax, 14              ; Color
        mov [es:si+8], ax
        mov al, 82h             ; Function 82h - Draw
        mov [es:si], ax
        mov al, 0fh             ; SubFunction 0eh - Paint rect around area
        mov [es:si+2], ax
        mov al, dl              ; Col
        mov [es:si+4],ax
        mov al, dh              ; Row
        mov [es:si+6],ax
        mov [es:si+10], cs      ; Seg
        mov ax, fieldinfoblock
        mov [es:si+12], ax      ; Off
        int 0FFh
        ret

dataseg dw 0
dataoff dw 0
snstatus:   db 'Snake (by simbone@gmx.at)'
yscoreptr:
yscore      dw 2020h, 2020h
            db ' Score: '
snscore:    db '0',0,0,0,0,0

    ; ---- VARIABLES

wnd         dw 0                ; Window-handle
foodpos     dw 0                ; Food's pos
snakelen    dw 1                ; Length
snakeadd    dw 4                ; Additionan length
snakedir    db 2                ; Dir (1,2,3,4 = L,R,O,U)
score       dw 0                ; Score
dopause     db 0                ; Pausing

fieldinfoblock: dw 80,50,0,0,0,8    ; 80x50 - Spacing (0,0)-(0,8)
            dw 0                    ; Additional field: BGCOLOR 0

snakepos:
snakehead   db 5,5              ; Startpos.

    ; DON'T PUT ANYTHING BELOW THIS LINE
    ; IT WILL BE OVERWRITTEN

wndstruct:
myself:     dw 0xFFFF
            dw 32+64+8      ; Flags: WF_TITLE + WF_ICON_SPRITE
            dw 0,0,0,0      ; x,y,w,h
            dw 0,0          ; wprg
            dw titl         ; title OFF
storcs:     dw 0            ; title SEG
            dw icon
storcs2:    dw 0            ; icon
            dw 3            ; fill                   
titl:       db 'Snake',0
icon:
            db 'A      ',10
            db 'A  AAAA',10
            db 'AAAA  A',10
            db '      A',10
            db ' AAAAAA',10
            db ' A     ',10
            db ' AAA B ',0

eoflbl:     db ''
