// Headerfile for Task- and Messagehandling

// Other constants
#define DEFAULTSTACK 1536   // defines the initital stacksize for new processes

// Messages
#define MSG_GENERICMOUSE 0x3
#define MSG_GENERICKEYB 0x4
#define MSG_GENERICTIMER 0x5
#define MSG_KILL 0x5
#define MSG_FLASH 0x6
#define MSG_PAINT 0x4000
#define MSG_CLOSEWND 0x4001     // 16385
#define MSG_MOUSEMOVE 0x4002    // 16386
#define MSG_MOUSEBUTTON 0x4003  // 16387
#define MSG_KEYDOWN 0x4004      // 16388
#define MSG_KEYUP 0x4005        // 16389
#define MSG_KEYPRESS 0x4006     // 16390
#define MSG_CLICK 0x4007
#define MSG_SCROLLBUTTON 0x4008
#define MSG_SCROLLCHANGE 0x4009
#define MSG_ITEMSELECT 0x4010
#define MSG_SCROLL 0x4011

// Process based user msgs: 0x3000-0x3FFF
// Window based user msgs : 0x5000-0x5FFF

#define TS_RUNNING 0
#define TS_SLEEP 1
#define TS_GETMESSAGE 2
#define TS_OTHERTASK 3
#define TS_STOPPED 4
#define TS_MESSAGEORHANDLE 5

#define MS_WANTMOUSEMSG 0x1
#define MS_WANTKEYBMSG 0x2
#define MS_WANTTIMERMSG 0x3

#define PID_BROADCAST 0xFFFF

UINT lcreat=0;
int dohlt=1;


sendmessage(UCHR tfrom, UCHR tto, UINT id, UINT dataa, UINT datab, UINT datac)
    {
    int i;
    if(tto == PID_BROADCAST)
        {
        for(i=0;i<TASKS_MAX;i++)
            if(tasks[i].used)
                sendmessage(tfrom,i,id,dataa,datab,datac);
        return 0;
        }
    if(tasks[tto].used == 0) return ERR_INVALIDPID;
    if(tasks[tfrom].used == 0) return ERR_INVALIDPID;
    for(i=0;i<MSGTAB_MAX;i++)
        if(tasks[tto].msg[i].used == 0)
            {
            tasks[tto].msg[i].used = 1;
            tasks[tto].msg[i].sender = tfrom;
            tasks[tto].msg[i].msgid = id;
            tasks[tto].msg[i].a = dataa;
            tasks[tto].msg[i].b = datab;
            tasks[tto].msg[i].c = datac;
            return 0;
            }
    return ERR_MSGQUEUEFULL;
    }

sendmessagesingle(UCHR tfrom, UCHR tto, UINT id, UINT dataa, UINT datab, UINT datac)
    {
    int i;
    if(tto == PID_BROADCAST)
        {
        for(i=0;i<TASKS_MAX;i++)
            if(tasks[i].used)
                sendmessagesingle(tfrom,i,id,dataa,datab,datac);
        return 0;
        }
    if(tasks[tto].used == 0) return ERR_INVALIDPID;
    if(tasks[tfrom].used == 0) return ERR_INVALIDPID;
    for(i=0;i<MSGTAB_MAX;i++)
        if(tasks[tto].msg[i].used && tasks[tto].msg[i].msgid == id)
            goto takth;
    for(i=0;i<MSGTAB_MAX;i++)
        if(tasks[tto].msg[i].used == 0)
            {
            takth:;
            tasks[tto].msg[i].used = 1;
            tasks[tto].msg[i].sender = tfrom;
            tasks[tto].msg[i].msgid = id;
            tasks[tto].msg[i].a = dataa;
            tasks[tto].msg[i].b = datab;
            tasks[tto].msg[i].c = datac;
            return 0;
            }
    beeper();
    return ERR_MSGQUEUEFULL;
    }

int peekmessage(UCHR pid)
    {
    int i;
    if(tasks[pid].used == 0) return ERR_INVALIDPID;
    for(i=0;i<MSGTAB_MAX;i++)
        if(tasks[pid].msg[i].used)
            {
            tasks[pid].msg[i].used = 0;
            return i;
            }
    return ERR_NOMSG;
    }

int getmessage(UCHR pid)
    {
    int i;
    tasks[pid].status = TS_GETMESSAGE;
    while((i = peekmessage(pid)) == ERR_NOMSG)
        idle();
    tasks[pid].status = TS_RUNNING;
    return i;
    }
    
void task_init(char *argvnam)
    {
    int i;
    for(i=1;i<TASKS_MAX;i++)
        tasks[i].used = 0;

    tasks[0].used = 2;
    tasks[0].filename = "/dev/kcore";
    tasks[0].params = argvnam;
    tasks[0].curdir = "/";
    tasks[0].ss = 0xFFFF;
    tasks[0].sp = 0xFFFF;
    }

postmessage(UCHR tfrom, UCHR tto, UINT id, UINT dataa, UINT datab, UINT datac )
    {
    int i;
    while((i = sendmessage(tfrom,tto,id,dataa,datab,datac)) == ERR_MSGQUEUEFULL)
        idle();
    return i;
    }

task_sleep(int pid, unsigned long time)
    {
    tasks[pid].status = TS_SLEEP;
    tasks[pid].status2 = (time / 10) + clock();
    idle();
    tasks[pid].status = TS_RUNNING;
    }

mkulwin(int hndl, char *str);
int task_create(char *fnam, char *params, int caller)
    {
    int id,ii;
    int hndl;
    char *pdata;
    UINT *sdata;
    UINT flg,stacksiz,numload;
    UINT i, et;
    char as[9];
//    printf("task_create(\"%s\",\"%s\",%i);\n",fnam,params,caller);
    for(id=lcreat;id<TASKS_MAX;id++)
        if(tasks[id].used == 0)
            goto tcidfnd;
    lcreat = 1;
    for(id=1;id<TASKS_MAX;id++)
        if(tasks[id].used == 0)
            goto tcidfnd;
    return ERR_TOOMANYTASKS;
    tcidfnd:
    lcreat = id + 1;

    if((hndl = fsopenrel(fnam,tasks[caller].curdir,id)) < 0)
        return hndl;

    as[2] = 0;
    fsread(hndl,2,as);
    if(!strcmp(as,"->"))
        et = 0;
    else if(!strcmp(as,"SL"))
        et = 1;
    else
        return ERR_INVALIDEXE;

    flg = fsgetc(hndl);
    if(et)
        {
            // Handle Ulsop-flags
        fsgetc(hndl);   // ulsop flags are 16-bit (8 bit are res.)
        if(flg & 32)
            stacksiz = fsgetw(hndl)*16;
        else
            stacksiz = DEFAULTSTACK;
        if(flg & 16)
            {
            as[8] = 0;
            fsread(hndl,8,as);
            }
        if(flg & 64)
            {
            numload = fsgetw(hndl);
            printf("ULAPP: Reserved: %u",numload);
            }
        else
            numload = fhandles[hndl].len - fhandles[hndl].pos;
        }
    else
        {
            // Handle Ilas-flags
        if(flg & 1)
            stacksiz = fsgetw(hndl);
        else
            stacksiz = DEFAULTSTACK;
        if(flg & 2)
            numload = fsgetw(hndl);
        else
            numload = fhandles[hndl].len - fhandles[hndl].pos;
        }
    printf("Creating task: ET=%i,NUMLOAD=%u,STACK=%u",et,numload,stacksiz);
    if((pdata = mem_malloc(numload,id)) < 0)
        {
        fsclose(hndl);
        return ERR_OUTOFMEMORY;
        }
    if((sdata = (UINT *) mem_malloc((stacksiz = (stacksiz + 31) & 0xFFE0),id)) < 0)
        {
        fsclose(hndl);
        mem_free(pdata);
        return ERR_OUTOFMEMORY;
        }
    if((ii=fsread(hndl,numload,pdata)) < 0)
        {
        fsclose(hndl);
        mem_free(pdata);
        mem_free((void *) sdata);
        return ii;
        }

//    if(et)
//        {
//        printf("ULSOP-Program loaded at %.4X\n",FP_SEG(pdata));
//        system("debug");
//        }

    tasks[id].used = 1;
    tasks[id].filename = makeabs(fnam, tasks[caller].curdir);
    tasks[id].params = mem_strnew(params, id);
    tasks[id].curdir = mem_strnew(tasks[caller].curdir, id);
    tasks[id].ss = FP_SEG(sdata);
    tasks[id].sp = stacksiz - 6;
    tasks[id].status = TS_RUNNING;
    tasks[id].msgstat = 0;
    sdata = (UINT *) (((UCHR *) sdata) + stacksiz);

    _asm
        {
        sti
        pushf
        pop ax
        mov i, ax
        }
    sdata[-3] = 0;
    sdata[-2] = FP_SEG(pdata);
    sdata[-1] = i;
    printf("created");

    if(flg & 16 && et)
        mkulwin(id,as);
    return id;
    }

waitmessageorhandle(int pid, int handle)
    {
    tasks[pid].status = TS_MESSAGEORHANDLE;
    tasks[pid].status2 = handle;
    idle();
    tasks[pid].status = TS_RUNNING;
    }

istaskready(int pid)
    {
    int i;
    switch(tasks[pid].status)
        {
        case TS_RUNNING: return 1;
        case TS_SLEEP: return clock() >= tasks[pid].status2;
        case TS_GETMESSAGE:
        case TS_MESSAGEORHANDLE:
            {
            for(i=0;i<MSGTAB_MAX;i++)
                if(tasks[pid].msg[i].used)
                    return 1;
            if(tasks[pid].status == TS_MESSAGEORHANDLE)
                { 
                i = tasks[pid].status2;
                if((fhandles[i].drvres[1] != fhandles[i].drvres[2]) || (fhandles[i].drvres[4]))
                    return 1;
                }
            return 0;
            }
        case TS_OTHERTASK: return !tasks[tasks[pid].status2].used;
        case TS_STOPPED: return 0;
        }
    return 1;   // status unknown - assume task is ready
    }

char *getnewstack(char *oldstack)
    {
    int ruthere=1;
    tasks[curtask].ss = FP_SEG(oldstack);
    tasks[curtask].sp = FP_OFF(oldstack);
    _asm sti;

    for(curtask++;curtask < TASKS_MAX;curtask++)
        if(tasks[curtask].used && istaskready(curtask)) goto dothetask;

    while(ruthere)
        {
        ruthere = 0;
        for(curtask=0;curtask < TASKS_MAX;curtask++)
            if(tasks[curtask].used)
                { ruthere=(curtask!=0); if(istaskready(curtask)) goto dothetask; }
        if(dohlt) _asm hlt;
        }
    debstr("leaving ilas-os: no more tasks");
    osexit();
                               
    dothetask:
    return MK_FP(tasks[curtask].ss,tasks[curtask].sp);
    }

/* void init_multitasking()
    {
    char *a;
    UINT i,j;
    a = getnewstack(NULL);

    i = FP_SEG(a); j = FP_OFF(a);
    _asm
        {
        mov ax, i
        mov bx, j
        cli
        mov ss, ax
        mov sp, bx
        sti
        iret
        }
    } */

void task_quit(int id)
    {
    if(id == -1) id = curtask;
    if(!id) return;
//    printf("task_quit(%i);\n",id);
    printf("cleanup: gui,");
    gui_cleanup(id);
    printf("wm,");
    wm_cleanup(id);
    printf("fs,");
    fs_cleanup(id);
    tasks[id].used = 0;
    printf("mem,");
    mem_cleanup(id);
    printf("done");
    if(id == curtask) // Call idle, so the task will never return
        idle();
    }

