CPU 286
ORG -5

%include "const.inc"

    db '->'     ; Begin
    db 2        ; Flags
    dw eoflbl+64   ; Add a buffer

;-------------------------------------------------

        mov ax, cs
        mov ds, ax
        mov [storcs], ax
        mov [storcs2], ax

        mov ax, 22h         ; set message status
        mov bx, MS_WANTTIMERMSG
        int 0F0h

        mov ax, 26h
        int 0F0h
        mov [myself], bx

        mov ax, 1016h       ; Create window
        mov si, wndstruct
        int 0F0h
        mov [wnd], ax

        mov ax, 30h         ; create stringlist
        mov cx, 8           ; allocby
        int 0F0h
        mov ax, es
        mov [tasklist], ax

        mov ax, 2009h       ; create listbox
        mov dx, [wnd]
        mov bx, 10
        mov cx, 10
        mov si, 310
        mov di, 150
        int 0F0h
        mov [tasklistbox], ax

        mov ax, 2004h       ; create label
        mov dx, [wnd]
        mov bx, 15
        mov cx, 157
        mov si, freemem
        xor di, di
        push di
        pop es
        int 0F0h
        mov [freelbl], ax

        mov ax, 2002h       ; create button
        mov dx, [wnd]
        mov bx, 270
        mov cx, 155
        mov si, closetext
        int 0F0h
        mov [closebtn], ax

        mov ax, 2002h       ; create button
        mov dx, [wnd]
        mov bx, 180
        mov cx, 155
        mov si, killtext
        int 0F0h
        mov [killbtn], ax


        call maketl

    ; -------------------------------------------------------------
    ; --------------------- MAIN MESSAGE LOOP ---------------------
    ; -------------------------------------------------------------
gmloop:
        mov ax, 10h         ; Getmessage
        int 0F0h
        mov ax, 2000h       ; Dispatchmessage
        int 0F0h
        cmp dx, MSG_GENERICTIMER
        jz istimer
        cmp dx, MSG_CLICK
        jnz gmloop
        cmp si, [wnd]       ; not the wnd
        jnz gmloop

        cmp di, [closebtn]
        jz endme
        cmp di, [killbtn]
        jz killproc
        jmp gmloop

endme:  xor ax, ax
        int 0F0h

istimer:
        mov ax, si
        sub ax, [lnum]

        cmp ax, 1000
        jb gmloop

        mov [lnum], si
dotimer:
        call maketl
        call painttl
        jmp gmloop

killproc:
        mov ax, 2019h
        mov dx, [tasklistbox]
        int 0F0h
        xor cx, cx
        cmp dx, 0FFFFh
        jnz killit

        mov ax, 38h         ; msgbox
        mov si, selectpid
        int 0F0h
        jmp gmloop

killit:
        or dx, dx
        jz pidgot
        mov ax, 45h
        int 0F0h
        dec dx
        jmp killit
pidgot:
        mov dx, cx
        mov ax, 52h         ; Kill process
        int 0F0h
        mov ax, 2020h       ; repaint screen
        int 0F0h

        jmp dotimer


maketl:
        mov ax, [tasklist]
        xor di, di
        mov es, ax
        mov ax, 36h         ; Clear stringlist
        int 0F0h

        xor cx, cx          ; Set first task
gtl:
        push cx
        mov ax, 46h         ; Get basic infos
        int 0F0h
        mov ax, es
        push cs
        pop es
        mov ds, ax
        mov di, somebuf
        mov ax, 49h         ; Copy string DS:SI->ES:DI
        int 0F0h

        mov ax, cs
        mov ds, ax

        mov ax, 48h         ; Fill string up to some chars
        mov si, somebuf
        mov bl, ' ' ; Fill with space
        mov cx, 18  ; Up to 18 chars
        int 0F0h

        pop cx
        push cx
        inc cx
        mov ax, 16h         ; Get app's memory usage
        int 0F0h
        mov cx, ax
        mov ax, 51h         ; Convert num. para to string
        mov di, somebuf+18
        int 0F0h


            ; Add the string to the SL
        mov ax, [tasklist]
        xor di, di
        mov es, ax

        mov ax, 31h         ; Additem
        mov si, somebuf
        int 0F0h
        pop cx

        mov ax, 45h
        int 0F0h
        cmp cx, 0FFFFh
        jnz gtl

        
        mov ax, 16h         ; Get app's memory usage
        xor cx, cx
        int 0F0h
        mov cx, ax
        mov ax, 51h         ; Convert num. para to string
        mov di, stofreemem
        int 0F0h

        mov ax, 2018h
        mov dx, [freelbl]
        mov si, freemem
        int 0F0h

        ret

painttl:
        mov ax, 2017h       ; Repaintele
        mov dx, [tasklistbox]
        int 0F0h

        mov ax, 2017h       ; Repaintele
        mov dx, [freelbl]
        int 0F0h
        ret


wnd:            dw 0
tasklist:       dw 0
tasklistbox:    dw 0
lnum:           dw 0
freelbl:        dw 0
closebtn:       dw 0
killbtn:        dw 0
selectpid:      db 'Select a task to kill',0
closetext:      db 'End',0
killtext:       db 'Kill Task',0
freemem:        db 'Free Bytes: '
stofreemem:     db '1M'
    ; DATA BELOW WILL BE OVERWRITTEN

somebuf:        ; Recycling title, wndstructs, etc.
wndstruct:    
myself:     dw 0xFFFF
            dw 32+64+8      ; Flags: WF_TITLE + WF_ICON_SPRITE + WF_FILL
            dw 0,0,0,0      ; x,y,w,h
            dw 0,0          ; wprg
            dw titl         ; title OFF
storcs:     dw 0            ; title SEG
            dw icon
storcs2:    dw 0            ; icon
            dw 9            ; fill
titl:       db 'Taskmanager',0
icon:       db ' LLLLL',10
            db 'LOOOOOL',10
            db 'OLLLLLO',10
            db 'MOOOOOM',10
            db 'JMMMMMJ',10
            db 'KJJJJJK',10
            db ' KKKKK',0
eoflbl: db ''
